//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4AB7A1B002AB.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4AB7A1B002AB.cm

//## begin module%4AB7A1B002AB.cp preserve=no
//## end module%4AB7A1B002AB.cp

//## Module: PlotCommand%4AB7A1B002AB; Package body
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotCommand.cxx

//## begin module%4AB7A1B002AB.additionalIncludes preserve=no
//## end module%4AB7A1B002AB.additionalIncludes

//## begin module%4AB7A1B002AB.includes preserve=yes
#include <XSContainer.h>
#include <XSstreams.h>
#include <XSFit/Fit/Fit.h>
#include <XSPlot/Plot/PlotGroupCreator.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSModel/GlobalContainer/DataContainer.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
//## end module%4AB7A1B002AB.includes

// PlotCommand
#include <XSPlot/Plot/PlotCommand.h>
//## begin module%4AB7A1B002AB.declarations preserve=no
//## end module%4AB7A1B002AB.declarations

//## begin module%4AB7A1B002AB.additionalDeclarations preserve=yes
//## end module%4AB7A1B002AB.additionalDeclarations


// Class PlotCommand 

//## begin PlotCommand::dataStatus%4ACDF9610125.attr preserve=no  protected: static bool {U} false
bool PlotCommand::s_dataStatus = false;
//## end PlotCommand::dataStatus%4ACDF9610125.attr

//## begin PlotCommand::activeModelStatus%4ACDFA400384.attr preserve=no  protected: static bool {U} false
bool PlotCommand::s_activeModelStatus = false;
//## end PlotCommand::activeModelStatus%4ACDFA400384.attr

//## begin PlotCommand::standardModelStyle%4AD61C2303D3.attr preserve=no  public: static PlotStyle::LineStyle {UC} PlotStyle::SOLID
const PlotStyle::LineStyle PlotCommand::s_standardModelStyle = PlotStyle::SOLID;
//## end PlotCommand::standardModelStyle%4AD61C2303D3.attr

//## begin PlotCommand::standardDataStyle%4AD61D7A003B.attr preserve=no  public: static PlotStyle::Symbol {UC} PlotStyle::DOT
const PlotStyle::Symbol PlotCommand::s_standardDataStyle = PlotStyle::DOT;
//## end PlotCommand::standardDataStyle%4AD61D7A003B.attr


PlotCommand::PlotCommand (const string& cmdName, PlotGroupCreator* plotGroupStrategy)
  //## begin PlotCommand::PlotCommand%4AB7A793021B.hasinit preserve=no
  //## end PlotCommand::PlotCommand%4AB7A793021B.hasinit
  //## begin PlotCommand::PlotCommand%4AB7A793021B.initialization preserve=yes
  : m_cmdName(cmdName),
    m_plotGroupStrategy(plotGroupStrategy),
    m_doesTakeParameters(false),
    m_isDataRequired(false),
    m_isActiveModelRequired(false),
    m_isDivisibleByArea(false),
    m_addCompLevel(0),
    m_isBackgroundApplicable(false),
    m_isLineIDApplicable(false),
    m_isPlotGroupDonor(false),
    m_isContour(false),
    m_styleMap(),
    m_rangeSettings()
  //## end PlotCommand::PlotCommand%4AB7A793021B.initialization
{
  //## begin PlotCommand::PlotCommand%4AB7A793021B.body preserve=yes
  //## end PlotCommand::PlotCommand%4AB7A793021B.body
}


PlotCommand::~PlotCommand()
{
  //## begin PlotCommand::~PlotCommand%4AB7A48D003B_dest.body preserve=yes
   delete m_plotGroupStrategy;
  //## end PlotCommand::~PlotCommand%4AB7A48D003B_dest.body
}



//## Other Operations (implementation)
void PlotCommand::commonInit ()
{
  //## begin PlotCommand::commonInit%4ACDFAE10101.body preserve=yes
  using namespace XSContainer;
  const ModelMap& mods = models->modelSet();
  ModelMapConstIter mm (mods.begin());
  ModelMapConstIter mmEnd (mods.end());  
  s_activeModelStatus = false;
  while (mm != mmEnd)
  {
     if (mm->second->isActive())
     {
        s_activeModelStatus = true;
	break;
     }
     ++mm;
  }
  
  s_dataStatus = datasets->numberOfSpectra();
  //## end PlotCommand::commonInit%4ACDFAE10101.body
}

void PlotCommand::verifyState () const
{
  //## begin PlotCommand::verifyState%4ACDFB9102E5.body preserve=yes
  if (m_isDataRequired && !s_dataStatus)
  {
     throw YellowAlert(" No data loaded\n");
  }
  
  if (m_isActiveModelRequired && !s_activeModelStatus)
  {
     throw YellowAlert(" No active models found\n");
  }
  
  // If command is capable of plotting data and model together,
  // and both currently exist, give a warning if the fit is not 
  // up to date.
  if (m_styleMap.find(PlotStyle::DATA) != m_styleMap.end() &&
      m_styleMap.find(PlotStyle::MODEL) != m_styleMap.end() &&
      s_dataStatus && s_activeModelStatus &&
      !XSContainer::fit->isStillValid())
  {
     tcout << "***Warning: Fit is not current." << std::endl;
  }
  //## end PlotCommand::verifyState%4ACDFB9102E5.body
}

void PlotCommand::setStyleMap (PlotStyle::VectorCategory category, const PlotAttributes& attributes)
{
  //## begin PlotCommand::setStyleMap%4AD5FAF101AD.body preserve=yes
   // No checking for pre-existing entries.
   m_styleMap[category] = attributes;
  //## end PlotCommand::setStyleMap%4AD5FAF101AD.body
}

void PlotCommand::processPlotGroups (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotCommand::processPlotGroups%4ADCD6E4013B.body preserve=yes
   manipulate(plotGroups, settings);
   setRanges(plotGroups, settings);
  //## end PlotCommand::processPlotGroups%4ADCD6E4013B.body
}

void PlotCommand::manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotCommand::manipulate%4ACCDD2003B7.body preserve=yes
  //## end PlotCommand::manipulate%4ACCDD2003B7.body
}

void PlotCommand::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotCommand::makeLabels%4B01BC0C01F2.body preserve=yes
  //## end PlotCommand::makeLabels%4B01BC0C01F2.body
}

bool PlotCommand::requestNewXoption (const PlotSettings& settings, XaxisMode& newOption) const
{
  //## begin PlotCommand::requestNewXoption%4B3A1C8F035F.body preserve=yes
   // Don't do anything here in the base class.
   return false;
  //## end PlotCommand::requestNewXoption%4B3A1C8F035F.body
}

void PlotCommand::processAdditionalParams (const StringArray& args, const IntegerArray& argIndices)
{
  //## begin PlotCommand::processAdditionalParams%4B3A780E0021.body preserve=yes
  //## end PlotCommand::processAdditionalParams%4B3A780E0021.body
}

string PlotCommand::processSuperAndSub (const string& inString)
{
  //## begin PlotCommand::processSuperAndSub%4B573CAA0293.body preserve=yes
   // This expects inString to come from the parameter names and 
   // optional parentheses-enclosed unit strings stored in in model.dat.
   // Therefore it is rather simplistic.  It only treats the first 
   // subscript ('_') found in the name portion of inString, and the
   // first superscript ('^') found in the optional units portion.
   // The subscript is assumed to run to the end of the name portion,
   // while the superscript is assumed to run until a ')'.
    
   // If the user has a more complicated mixture of super/subscripts
   // in their own lmodel.dat, chances are this isn't going to do what
   // they want, in which case they'll need to modify it with their
   // own PLT command.
   
   
   string outString;
   // The (npos-6) case should never arise, but each replacement nets
   // +3 characters, and we want to make sure there's room for both. 
   if (inString.length() && inString.length() < (string::npos - 6))
   {
      const string WS(" \t");
      const string::size_type firstWS = inString.find_first_of(WS);
      const string::size_type subLoc = inString.find('_');
      if (subLoc < firstWS)
      {
         outString = inString.substr(0, subLoc);
         outString += "\\d";
         outString += inString.substr(subLoc+1, firstWS-(subLoc+1));
         outString += "\\u";
      }
      else
         // Underscore either doesn't exist at all or is in the 2nd
         // portion of inString.
         outString = inString.substr(0,firstWS);
      
      if (firstWS != string::npos)
      {
         const string::size_type unitLoc = inString.find_first_not_of(WS,firstWS);
         if (unitLoc != string::npos)
         {
            // Pick up the whitespace between the 2 portions.
            outString += inString.substr(firstWS, unitLoc-firstWS);
            const string::size_type superLoc = inString.find('^',unitLoc);
            if (superLoc != string::npos)
            {
               outString += inString.substr(unitLoc, superLoc-unitLoc);
               outString += "\\u";
               string::size_type endLoc = inString.find(')');
               // If ')' doesn't exist, this will still work.
               outString += inString.substr(superLoc+1, endLoc-(superLoc+1));
               outString += "\\d";
               if (endLoc < inString.length())
               {
                  outString += inString.substr(endLoc);
               }
               
            }
            else
               outString += inString.substr(unitLoc);
         }
      }
   }
   
   return outString;
  //## end PlotCommand::processSuperAndSub%4B573CAA0293.body
}

std::vector<PlotGroup*> PlotCommand::makePlotGroups (const PlotSettings& settings, const std::vector<const PlotGroup*>& donatedPlotGroups)
{
  //## begin PlotCommand::makePlotGroups%4B6336D70114.body preserve=yes
   // Default version: don't use any donated plot groups.
   return m_plotGroupStrategy->createPlotGroups(settings);
  //## end PlotCommand::makePlotGroups%4B6336D70114.body
}

// Additional Declarations
  //## begin PlotCommand%4AB7A48D003B.declarations preserve=yes
  //## end PlotCommand%4AB7A48D003B.declarations

//## begin module%4AB7A1B002AB.epilog preserve=yes
//## end module%4AB7A1B002AB.epilog
